# Copyright (c) 2000-2011, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%define with()          %{expand:%%{?with_%{1}:1}%%{!?with_%{1}:0}}
%define without()       %{expand:%%{?with_%{1}:0}%%{!?with_%{1}:1}}
%define bcond_with()    %{expand:%%{?_with_%{1}:%%global with_%{1} 1}}
%define bcond_without() %{expand:%%{!?_without_%{1}:%%global with_%{1} 1}}

%bcond_without jbossas
%bcond_without repolib

%define namedversion %{version}

%define repodir %{_javadir}/repository.jboss.com/juddi/%{namedversion}-brew
%define repodirlib %{repodir}/lib
%define repodirsrc %{repodir}/src

%define section free

%define basedir %{_localstatedir}/lib/%{name}
%define appdir %{basedir}/webapps
%define wsdir %{basedir}/ws
%define sqldir %{basedir}/sql
%define homedir %{_datadir}/%{name}

Name:           juddi
Version:        2.0.1
Release:        4%{?dist}
Epoch:          0
Summary:        Open source Java implementation UDDI specification
License:        ASL 2.0
Group:          Development/Libraries/Java
URL:            http://ws.apache.org/juddi/
# svn export http://svn.apache.org/repos/asf/juddi/tags/juddi-2.0.1/ && tar cjf juddi-2.0.1.tar.bz2 juddi-2.0.1/
# Exported revision 1080709.
Source0:        juddi-2.0.1.tar.bz2
Source1:        juddi-component-info.xml
# Depmap to convert mismatched Maven coordinates
Source2:        %{name}-jpp-depmap.xml
# Things we need to patch
Patch0:         %{name}-site_xml.patch
Patch1:         %{name}-build.patch
Patch2:         %{name}-axis-build.patch
Patch3:         %{name}-poms.patch
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:       jpackage-utils
# Basic stuff
BuildRequires:  jpackage-utils
BuildRequires:  java
BuildRequires:  java-devel
# Maven and its dependencies
BuildRequires:  maven2
BuildRequires:  maven2-plugin-antrun
BuildRequires:  maven2-plugin-assembly
BuildRequires:  maven2-plugin-clean
BuildRequires:  maven2-plugin-compiler
BuildRequires:  maven2-plugin-dependency
BuildRequires:  maven2-plugin-install
BuildRequires:  maven2-plugin-jar
BuildRequires:  maven2-plugin-javadoc
BuildRequires:  maven2-plugin-one
BuildRequires:  maven2-plugin-release
BuildRequires:  maven2-plugin-resources
BuildRequires:  maven2-plugin-site
BuildRequires:  maven2-plugin-source
BuildRequires:  maven2-plugin-war
BuildRequires:  maven2-plugin-deploy
BuildRequires:  maven-doxia-sitetools
BuildRequires:  maven-jdocbook-plugin
BuildRequires:  maven-shared
BuildRequires:  maven-shared-file-management
BuildRequires:  maven-shared-reporting-impl
BuildRequires:  maven-shared-model-converter
BuildRequires:  maven-shared-plugin-tools-api
BuildRequires:  maven-surefire
BuildRequires:  maven-surefire-maven-plugin
BuildRequires:  maven-surefire-provider-junit4
BuildRequires:  maven-wagon
BuildRequires:  plexus-archiver
BuildRequires:  plexus-compiler
BuildRequires:  plexus-containers-container-default
BuildRequires:  plexus-i18n
BuildRequires:  plexus-utils
BuildRequires:  plexus-velocity
# BuildRequires for jUDDI itself
BuildRequires:  jakarta-commons-logging >= 0:1.1
BuildRequires:  log4j >= 0:1.2.13
BuildRequires:  jboss-jaxr
BuildRequires:  jbossws-parent
BuildRequires:  jbossws
BuildRequires:  xml-commons-jaxp-1.3-apis
# BuildRequires for jUDDI not listed
BuildRequires:  jbossweb-servlet-2.5-api
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
jUDDI (pronounced "Judy") is an open source Java implementation 
of the Universal Description, Discovery, and Integration (UDDI) 
specification for Web Services.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%package javadoc
Group:          Development/Documentation
Summary:        Javadoc for %{name}

%description javadoc
Javadoc for %{name}.

%package webapps
Summary:        Webapps for %{name}
Group:          System Environment/Applications
Requires:       %{name} = %{epoch}:%{version}-%{release}
%if 0
Requires:       jakarta-commons-discovery
Requires:       log4j
Requires:       wsdl4j
%endif

%description webapps
Webapp for %{name}.

%if 0
# XXX: (dwalluck): These are already inside juddi.jar
%package sql-init-statements
Group:          Development/Libraries/Java
Summary:        SQL statements for database creation/configuration
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description sql-init-statements
SQL statements for creation/configuration of a database 
for storing web services metadata for %{name}.
%endif

%package ws
Group:          Development/Libraries/Java
Summary:        jUDDI Web Services
Requires:       %{name} = %{epoch}:%{version}-%{release}

%description ws
The Web Services for %{name}.

%prep
%setup -q
%{_bindir}/find -type f -name '*.jar' | %{_bindir}/xargs -t %{__rm}
%patch0 -p1 -b .sav0
%patch1 -p0 -b .sav1
%patch2 -p1 -b .sav2
%patch3 -p1 -b .sav3

%build
export MAVEN_REPO_LOCAL=$(pwd)/.m2/repository
%{_bindir}/mvn-jpp -e \
        -Dmaven.repo.local=${MAVEN_REPO_LOCAL} \
        -Dmaven2.jpp.depmap.file=%{SOURCE2} \
        -DaltDeploymentRepository=oss-releases::default::file:maven2-brew \
        install deploy:deploy javadoc:aggregate

%install
rm -rf %{buildroot}

%if 0
./juddi/juddi-parent/2.0.1/juddi-parent-2.0.1-site.xml
%endif

# jars
%{__mkdir_p} %{buildroot}%{_javadir}/%{name}

pushd maven2-brew

%{__cp} -p juddi/juddi/%{namedversion}/juddi-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi/%{namedversion}/juddi-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-client/%{namedversion}/juddi-client-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-client/%{namedversion}/juddi-client-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-ws/%{namedversion}/juddi-ws-%{namedversion}-sources.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-ws/%{namedversion}/juddi-ws-%{namedversion}.jar %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-web/%{namedversion}/juddi-web-%{namedversion}.war %{buildroot}%{_javadir}/%{name}
%{__cp} -p juddi/juddi-web-lean/%{namedversion}/juddi-web-lean-%{namedversion}.war %{buildroot}%{_javadir}/%{name}
(cd %{buildroot}%{_javadir}/%{name} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} -e "s|-%{namedversion}||g"`; done)

# poms
%{__mkdir_p} %{buildroot}%{_datadir}/maven2/poms
%{__cp} -p juddi/juddi/%{namedversion}/juddi-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi.pom
%{__cp} -p juddi/juddi-client/%{namedversion}/juddi-client-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-client.pom
%{__cp} -p juddi/juddi-parent/%{namedversion}/juddi-parent-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%{__cp} -p juddi/juddi-web/%{namedversion}/juddi-web-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-web.pom
%{__cp} -p juddi/juddi-web-lean/%{namedversion}/juddi-web-lean-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-web-lean.pom
%{__cp} -p juddi/juddi-ws/%{namedversion}/juddi-ws-%{namedversion}.pom %{buildroot}%{_datadir}/maven2/poms/JPP.%{name}-juddi-ws.pom

popd

# depmaps
%add_to_maven_depmap juddi juddi %{namedversion} JPP/%{name} juddi
%add_to_maven_depmap juddi juddi-client %{namedversion} JPP/%{name} juddi-client
%add_to_maven_depmap juddi juddi-parent %{namedversion} JPP/%{name} juddi-parent
%add_to_maven_depmap juddi juddi-web %{namedversion} JPP/%{name} juddi-web
%add_to_maven_depmap juddi juddi-web-lean %{namedversion} JPP/%{name} juddi-web-lean
%add_to_maven_depmap juddi juddi-ws %{namedversion} JPP/%{name} juddi-ws

# javadoc
install -d -m 755 %{buildroot}%{_javadocdir}/%{name}-%{version}
cp -pr target/site/apidocs/* %{buildroot}%{_javadocdir}/%{name}-%{version}
ln -s %{name}-%{version} %{buildroot}%{_javadocdir}/%{name}

%if %with repolib
%{__mkdir_p} %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew
%{__cp} -pr maven2-brew/* %{buildroot}%{_javadir}/repository.jboss.com/maven2-brew

install -d -m 755 %{buildroot}%{repodir}
install -d -m 755 %{buildroot}%{repodirlib}
install -p -m 644 %{SOURCE1} %{buildroot}%{repodir}/component-info.xml
sed -i "s/@VERSION@/%{namedversion}-brew/g" %{buildroot}%{repodir}/component-info.xml
tag=`echo %{name}-%{version}-%{release} | sed 's|\.|_|g'`
sed -i "s/@TAG@/$tag/g" %{buildroot}%{repodir}/component-info.xml
install -d -m 755 %{buildroot}%{repodirsrc}
install -p -m 644 %{SOURCE0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH0} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH1} %{buildroot}%{repodirsrc}
install -p -m 644 %{PATCH3} %{buildroot}%{repodirsrc}
cp -p %{buildroot}%{_javadir}/%{name}/juddi.jar %{buildroot}%{repodirlib}
cp -p %{buildroot}%{_javadir}/%{name}/juddi-%{version}-sources.jar %{buildroot}%{repodirlib}/juddi-sources.jar
cp -p %{buildroot}%{_javadir}/%{name}/juddi-client.jar %{buildroot}%{repodirlib}
%endif

%clean
rm -rf %{buildroot}

%files
%defattr(0644,root,root,0755)
%doc juddi-distribution/docs/Getting-Started.odt
%doc juddi-distribution/docs/Getting-Started.pdf
%doc juddi-distribution/LICENSE-2.0
%doc juddi-distribution/NOTICE
%doc juddi-distribution/README
%doc juddi-distribution/RELEASE-NOTES-v0.9.txt
%doc juddi-distribution/RELEASE-NOTES-v2.0.html
%dir %{_javadir}*/%{name}
%exclude %dir %{_javadocdir}/%{name}
%{_javadir}*/%{name}/juddi-%{namedversion}-sources.jar
%{_javadir}*/%{name}/juddi-sources.jar
%{_javadir}*/%{name}/juddi-%{namedversion}.jar
%{_javadir}*/%{name}/juddi.jar
%{_javadir}*/%{name}/juddi-client-%{namedversion}-sources.jar
%{_javadir}*/%{name}/juddi-client-sources.jar
%{_javadir}*/%{name}/juddi-client-%{namedversion}.jar
%{_javadir}*/%{name}/juddi-client.jar
%{_datadir}/maven2/poms/JPP.%{name}-juddi.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-client.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-parent.pom
%{_mavendepmapfragdir}/%{name}

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/%{name}-%{version}
%{_javadocdir}/%{name}

%files webapps
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/juddi-web-%{namedversion}.war
%{_javadir}*/%{name}/juddi-web.war
%{_javadir}*/%{name}/juddi-web-lean-%{namedversion}.war
%{_javadir}*/%{name}/juddi-web-lean.war
%{_datadir}/maven2/poms/JPP.%{name}-juddi-web.pom
%{_datadir}/maven2/poms/JPP.%{name}-juddi-web-lean.pom

%if 0
%files sql-init-statements
%defattr(0644,root,root,0755)
%endif

%files ws
%defattr(0644,root,root,0755)
%{_javadir}*/%{name}/juddi-ws-%{namedversion}-sources.jar
%{_javadir}*/%{name}/juddi-ws-sources.jar
%{_javadir}*/%{name}/juddi-ws-%{namedversion}.jar
%{_javadir}*/%{name}/juddi-ws.jar
%{_datadir}/maven2/poms/JPP.%{name}-juddi-ws.pom

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Fri Mar 11 2011 David Walluck <dwalluck@redhat.com> 0:2.0.1-4
- add poms
- add docs
- ws requires main package
- remove empty client dir from javadocs
- use jbossweb for servlet-api
- fix maven deps
- repodir should not have a star in it
- use %%{name} for juddi dir
- fix repolib
- fix mixed-use-of-spaces-and-tabs
- fix macros in comments

* Thu Mar 10 2011 Vaclav Tunka <vtunka@redhat.com> - 0:2.0.1-3.2
- Add patch to change groupIds from org.apache.juddi to juddi
- GroupId now conforms to component-matrix

* Wed Jan 13 2011 Vaclav Tunka <vtunka@redhat.com> - 0:2.0.1-3.1
- Change BR xml-commons-apis for xml-commons-jaxp-1.3-apis
- Add patch to disable axis integration with jUDDI
- Fix javadoc paths
- Add BR jboss-jaxr
- Clear redundant depmap entries

* Wed Dec 14 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-3
- Build with maven 2.2.1
- Add BR maven-deploy-plugin, maven-shared-model-converter
- Change javadoc:javadoc to javadoc:aggregate
- Change BR axis2-saaj to jbossws
- Add patch to avoid site issue

* Mon May 17 2010 Martha Benitez <mbenitez@redhat.com> - 0:2.0.1-2.1
- rebuilt

* Tue Apr 20 2010 Luiz Barreiros <gbarreir@redhat.com> 0:2.0.1-2
- Rebuild

* Tue Jul 28 2009 Fernando Nasser <fnasser@redhat.com> 0:2.0.1-1
- Upgrade to 2.0.1

* Tue Jul 28 2009 Fernando Nasser <fnasser@redhat.com> 0:2.0.0-1
- Upgrade to 2.0.0
- Make axis optional for juddi as it may be used in other containers

* Tue Jun 16 2009 Martha Benitez <mbenitez@redhat.com> 0:0.9-0.rc.4.1
- Build without jbossas

* Wed Oct 08 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.4
- add optional jboss authenticator requirement
- add junit and log4j build requirements
- fix version and tag in component-info.xml
- fix repolib directory ownership
- fix repolib permissions
- use cp instead of mv in %%install so as to not break --short-circuit

* Thu May 29 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.3.jpp5
- fix License
- remove PreReq tag
- fix summary-ended-with-dot
- add /Java to all Group tags

* Fri May 02 2008 David Walluck <dwalluck@redhat.com> 0:0.9-0.rc4.2jpp.ep1.3
- patch for jdk5 enum
- own %%{_javadir}/juddi directory
- remove javadoc scriptlets

* Tue Mar 13 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.ep1.2
- Fix repolib location

* Mon Mar 12 2007 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp.ep1.1
- Make axis optional for juddi as it may be used in other containers

* Tue Feb 20 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.el4ep1.2
- Add -brew suffix
- Export juddi.war in repolib

* Sat Feb 17 2007 Vivek Lakshmanan <vivekl@redhat.com> 0:0.9-0.rc4.2jpp.el4ep1.1
- Add repolib support

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp_1rh
- Merge with upstream

* Wed Dec 07 2005 Fernando Nasser <fnasser@redhat.com> 0:0.9-0.rc4.2jpp
- First JPP 1.7 build

* Fri Jul 22 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_3rh
- Removed the -b option from the patch directive as it is unnecessary.

* Thu Jul 21 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_2rh
- Cleaned up spec file.
- Removed spurious dependency from apps and webapps on the main package.

* Tue Jul 19 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp_1rh
- First Red Hat build

* Mon Jul 18 2005 Deepak Bhole <dbhole@redhat.com> 0:0.9-0.rc4.1jpp
- Initial build.
